/*
Authorization Service API v. 1.0

<a href='https://cern.service-now.com/service-portal?id=privacy_policy&se=SSO-Service&notice=resources'>Privacy notice</a>

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package authzapiv1

import (
	"encoding/json"
)

// checks if the Identifier type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &Identifier{}

// Identifier struct for Identifier
type Identifier struct {
	IdentifierType NullableString `json:"identifierType,omitempty"`
	Value          NullableString `json:"value,omitempty"`
	IsTaken        *bool          `json:"isTaken,omitempty"`
}

// NewIdentifier instantiates a new Identifier object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewIdentifier() *Identifier {
	this := Identifier{}
	return &this
}

// NewIdentifierWithDefaults instantiates a new Identifier object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewIdentifierWithDefaults() *Identifier {
	this := Identifier{}
	return &this
}

// GetIdentifierType returns the IdentifierType field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *Identifier) GetIdentifierType() string {
	if o == nil || IsNil(o.IdentifierType.Get()) {
		var ret string
		return ret
	}
	return *o.IdentifierType.Get()
}

// GetIdentifierTypeOk returns a tuple with the IdentifierType field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *Identifier) GetIdentifierTypeOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.IdentifierType.Get(), o.IdentifierType.IsSet()
}

// HasIdentifierType returns a boolean if a field has been set.
func (o *Identifier) HasIdentifierType() bool {
	if o != nil && o.IdentifierType.IsSet() {
		return true
	}

	return false
}

// SetIdentifierType gets a reference to the given NullableString and assigns it to the IdentifierType field.
func (o *Identifier) SetIdentifierType(v string) {
	o.IdentifierType.Set(&v)
}

// SetIdentifierTypeNil sets the value for IdentifierType to be an explicit nil
func (o *Identifier) SetIdentifierTypeNil() {
	o.IdentifierType.Set(nil)
}

// UnsetIdentifierType ensures that no value is present for IdentifierType, not even an explicit nil
func (o *Identifier) UnsetIdentifierType() {
	o.IdentifierType.Unset()
}

// GetValue returns the Value field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *Identifier) GetValue() string {
	if o == nil || IsNil(o.Value.Get()) {
		var ret string
		return ret
	}
	return *o.Value.Get()
}

// GetValueOk returns a tuple with the Value field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *Identifier) GetValueOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.Value.Get(), o.Value.IsSet()
}

// HasValue returns a boolean if a field has been set.
func (o *Identifier) HasValue() bool {
	if o != nil && o.Value.IsSet() {
		return true
	}

	return false
}

// SetValue gets a reference to the given NullableString and assigns it to the Value field.
func (o *Identifier) SetValue(v string) {
	o.Value.Set(&v)
}

// SetValueNil sets the value for Value to be an explicit nil
func (o *Identifier) SetValueNil() {
	o.Value.Set(nil)
}

// UnsetValue ensures that no value is present for Value, not even an explicit nil
func (o *Identifier) UnsetValue() {
	o.Value.Unset()
}

// GetIsTaken returns the IsTaken field value if set, zero value otherwise.
func (o *Identifier) GetIsTaken() bool {
	if o == nil || IsNil(o.IsTaken) {
		var ret bool
		return ret
	}
	return *o.IsTaken
}

// GetIsTakenOk returns a tuple with the IsTaken field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Identifier) GetIsTakenOk() (*bool, bool) {
	if o == nil || IsNil(o.IsTaken) {
		return nil, false
	}
	return o.IsTaken, true
}

// HasIsTaken returns a boolean if a field has been set.
func (o *Identifier) HasIsTaken() bool {
	if o != nil && !IsNil(o.IsTaken) {
		return true
	}

	return false
}

// SetIsTaken gets a reference to the given bool and assigns it to the IsTaken field.
func (o *Identifier) SetIsTaken(v bool) {
	o.IsTaken = &v
}

func (o Identifier) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o Identifier) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if o.IdentifierType.IsSet() {
		toSerialize["identifierType"] = o.IdentifierType.Get()
	}
	if o.Value.IsSet() {
		toSerialize["value"] = o.Value.Get()
	}
	if !IsNil(o.IsTaken) {
		toSerialize["isTaken"] = o.IsTaken
	}
	return toSerialize, nil
}

type NullableIdentifier struct {
	value *Identifier
	isSet bool
}

func (v NullableIdentifier) Get() *Identifier {
	return v.value
}

func (v *NullableIdentifier) Set(val *Identifier) {
	v.value = val
	v.isSet = true
}

func (v NullableIdentifier) IsSet() bool {
	return v.isSet
}

func (v *NullableIdentifier) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableIdentifier(val *Identifier) *NullableIdentifier {
	return &NullableIdentifier{value: val, isSet: true}
}

func (v NullableIdentifier) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableIdentifier) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
